AjpProcessor.SocketOutputBuffer (Apache Tomcat 9.0.75 API Documentation)

Package org.apache.coyote.ajp

## Class AjpProcessor.SocketOutputBuffer

- java.lang.Object
- - org.apache.coyote.ajp.AjpProcessor.SocketOutputBuffer

- All Implemented Interfaces:
    `OutputBuffer`
  Enclosing class:
    AjpProcessor

      protected class AjpProcessor.SocketOutputBuffer
      extends java.lang.Object
      implements OutputBuffer

  This class is an output buffer which will write data to an output stream.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `SocketOutputBuffer()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `doWrite​(java.nio.ByteBuffer chunk)` | Write the given data to the response.
    `long` | `getBytesWritten()` | Bytes written to the underlying socket.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SocketOutputBuffer

          protected SocketOutputBuffer()

  - ### Method Detail

    - #### doWrite

          public int doWrite​(java.nio.ByteBuffer chunk)
                      throws java.io.IOException

      Description copied from interface: `OutputBuffer`
      Write the given data to the response. The caller owns the chunks.
      Specified by:
        `doWrite` in interface `OutputBuffer`
      Parameters:
        `chunk` - data to write
      Returns:
        The number of bytes written which may be less than available in the input chunk
      Throws:
        `java.io.IOException` - an underlying I/O error occurred

    - #### getBytesWritten

          public long getBytesWritten()

      Description copied from interface: `OutputBuffer`
      Bytes written to the underlying socket. This includes the effects of chunking, compression, etc.
      Specified by:
        `getBytesWritten` in interface `OutputBuffer`
      Returns:
        Bytes written for the current request